package cv03;

import java.util.Scanner;

public class Ucty {

	public static Scanner sc = new Scanner(System.in);
	
	public static void main(String[] args) {
		Ucet vsechnyUcty = null;
		Ucet posledni = null;
		while(true){
			System.out.print("Zadejte jmeno uctu a castku (Karel [-]1000): ");
			String jmeno = sc.next();
				//ukonceni programu pri vyskytu definovanych slov
				if(ukoncit(jmeno)) break;
			String cash = sc.next();
			int castka = Integer.decode(cash.replace('+', ' ').trim());
			if(vsechnyUcty == null){
				/**/System.out.println("Zakladam prvni ucet:" +jmeno);
				vsechnyUcty = novyUcet(jmeno, castka);
				posledni = vsechnyUcty;
			}else {
				Ucet hledany = najdiUcet(vsechnyUcty,jmeno);
				if(hledany != null){
					/**/System.out.println("Ucet: "+jmeno+" existuje");
					operaceUctu(hledany,castka);
				}else {
					/**/System.out.println("Zakladam novy ucet: "+jmeno);
					posledni.setDalsiKlient(novyUcet(jmeno, castka));
					Ucet pom = posledni.getDalsiKlient();
					posledni = pom;
				}
			}
		}
		
		if(vsechnyUcty != null){
			debety(vsechnyUcty);
			zustatky(vsechnyUcty);
			vypisStrukturu(vsechnyUcty);
		}else {
			System.out.println("Nebyly zaloeny dn ty.");
		}
	}
	
	public static Ucet novyUcet(String jmeno, int castka){
		Ucet pom = new Ucet(jmeno);
		if(castka < 0){
			/**/System.out.println("Vybiram castku: "+castka);
			pom.vybery = new Polozka(castka);
		}else{
			/**/System.out.println("Vkladam castku: "+castka);
			pom.vklady = new Polozka(castka);
		}
		return pom;
	}
	
	public static Ucet najdiUcet(Ucet r, String jmeno){
		while(r != null){
			if(r.jmeno.compareToIgnoreCase(jmeno) == 0){
				return r;
			}else{
				r = r.getDalsiKlient();
			}
		}
		return null;
	}
	
	public static void operaceUctu(Ucet r, int castka){
		Polozka pom;
		if(castka < 0){
			if(r.vybery == null){
				/**/System.out.println("Vybiram castku: "+castka);
				r.vybery = new Polozka(castka);
			}else {
				pom = r.vybery;
				while(pom.dalsi != null){
					pom = pom.dalsi;
				}
				/**/System.out.println("Vybiram castku: "+castka);
				pom.dalsi = new Polozka(castka);
			}
			
		}else if(castka > 0) {
			if(r.vklady == null){
				/**/System.out.println("Vkladam castku: "+castka);
				r.vklady = new Polozka(castka);
			}else {
				pom = r.vklady;
				while(pom.dalsi != null){
					pom = pom.dalsi;
				}
				/**/System.out.println("Vkladam castku: "+castka);
				pom.dalsi = new Polozka(castka);
			}
		}
	}
	
	public static void debety(Ucet r){
		/**/boolean nobody = true;
		System.out.println("Debet ma:");
		while(r != null){
			if(r.maDebet()){
				System.out.println(r.getJmeno());
				nobody = false;
			}
			r = r.getDalsiKlient();
		}
		/**/if(nobody){
			System.out.println("dn z t nem debet.");
		}
	}
	
	public static void zustatky(Ucet r){
		System.out.println("\nZustatky pro vsechny ucty...");
		while(r != null){
			System.out.print(""+r.getJmeno()+": ");
			System.out.println(r.sectiVklady()+r.sectiVybery());
			r = r.getDalsiKlient();
		}
	}
	
	/**
	 * Vypise celou datovou strukturu spojoveho seznamu vsech ustu
	 * 
	 * @param r Ucet
	 */
	public static void vypisStrukturu(Ucet r){
		System.out.println("\nVypisuji celou datovou strukturu...");
		Polozka k;
		while(r != null){
			System.out.println("Jmeno: "+r.jmeno);
			System.out.print("Vklady: ");
			k = r.vklady;
			/**/if(k == null) System.out.print("dn vklady");
			while(k != null){
				System.out.print(k.obnos+", ");
				k = k.dalsi;
			}
			System.out.println();
			System.out.print("Vybery: ");
			k = r.vybery;
			/**/if(k == null) System.out.print("dn vbry");
			while(k != null){
				System.out.print(k.obnos+", ");
				k = k.dalsi;
			}
			System.out.println();
			System.out.println();
			r = r.getDalsiKlient();
		}
	}
	
	/**
	 * Porovna vstupni retezec na shodu s nami definovanymi retezci
	 * 
	 * @param s String
	 * @return TRUE pri shode, jinak FALSE
	 */
	public static boolean ukoncit(String s){
		if(s.compareToIgnoreCase("konec") == 0 
				|| s.compareToIgnoreCase("exit") == 0 
				|| s.compareToIgnoreCase("quit") == 0)
			return true;
		else return false;
	}

}
